#include "security.hpp"
#include <stdio.h>
#include <tchar.h>
#include <Aclapi.h>
#include <lm.h>
#include <LMAccess.h>
#include <Ntsecapi.h>
#include <subauth.h>
bool displayToken(HANDLE htok, bool toEnable = false);


// Useful helper function for enabling a single privilege
bool enableTokenPrivilege(HANDLE htok, LPCTSTR szPrivilege, TOKEN_PRIVILEGES& tpOld)
{
	bool result = false;
    TOKEN_PRIVILEGES tp;
    tp.PrivilegeCount = 1;
	DWORD cbOld;
    tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
    if (LookupPrivilegeValue(NULL, szPrivilege, &tp.Privileges[0].Luid))
    {
        // htok must have been opened with the following permissions:
        // TOKEN_QUERY (to get the old priv setting)
        // TOKEN_ADJUST_PRIVILEGES (to adjust the priv)
        cbOld = sizeof(TOKEN_PRIVILEGES);
        if (AdjustTokenPrivileges(htok, FALSE, &tp, cbOld, &tpOld, &cbOld))
            // Note that AdjustTokenPrivileges may succeed, and yet
            // some privileges weren't actually adjusted.
            // You've got to check GetLastError() to be sure!
		{
            result = (ERROR_NOT_ALL_ASSIGNED != GetLastError());
			if (result)
			{
			
			}
		}        
    }
	return result;
}


bool displayToken(HANDLE htok, bool toEnable)
{
	bool result = false, enable;
	LPBYTE buffer[1024];
	DWORD bufferSize = 1024;
	TCHAR nameBuffer[256];
	DWORD nameBufferSize;
	TOKEN_PRIVILEGES tpOld;
	PTOKEN_PRIVILEGES ptp = (PTOKEN_PRIVILEGES)buffer;
	if (GetTokenInformation(htok, TokenPrivileges, buffer, bufferSize, &bufferSize))
	{
		for (int i=0; i<ptp->PrivilegeCount; i++)
		{
			nameBufferSize = 256;
			if (LookupPrivilegeName(NULL, &ptp->Privileges[i].Luid, nameBuffer, &nameBufferSize))
			{
				enable = toEnable;
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED)
				{				
					enable = false;
					_tprintf(_T("[enabled]"));
				}
				if (ptp->Privileges[i].Attributes  & SE_PRIVILEGE_USED_FOR_ACCESS)
				{
					enable = false;
					_tprintf(_T("[access]"));
				}
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED_BY_DEFAULT)
				{
					enable = false;
					_tprintf(_T("[default]"));								
				}
				if (ptp->Privileges[i].Attributes &SE_PRIVILEGE_REMOVED)
				{
					enable = false;
					_tprintf(_T("[removed]"));
				}
				if (enable)
				{
					if (enableTokenPrivilege(htok, nameBuffer, tpOld))
					{
						_tprintf(_T("enabled by me..."));
					}
				}


				_tprintf(_T(" [%s]\n"), nameBuffer);
				result = true;
			
			}
			else
			{
				int err  = GetLastError();
			}
		}
	}
	return result;
}

HANDLE convertPrimaryToken(HANDLE pseudoHandle)
{
	HANDLE handle = NULL;;
	DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &handle, DUPLICATE_SAME_ACCESS, FALSE, DUPLICATE_SAME_ACCESS);
	return handle;
}

bool showPrivilege(bool toEnable)
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	TOKEN_PRIVILEGES tpOld;
	bool result =false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{		
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{
			displayToken(hToken, toEnable);
		}
	}
	printf("\n\n");
	displayToken(hToken);
	return result;
}



BOOL TakeOwnership(LPTSTR lpszOwnFile)
{
	BOOL bRetval = FALSE;

	HANDLE hToken = NULL;
	PSID pSIDAdmin = NULL;
	PSID pSIDEveryone = NULL;
	PACL pACL = NULL;
	SID_IDENTIFIER_AUTHORITY SIDAuthWorld = SECURITY_WORLD_SID_AUTHORITY;
	SID_IDENTIFIER_AUTHORITY SIDAuthNT = SECURITY_NT_AUTHORITY;
	const int NUM_ACES = 2;
	EXPLICIT_ACCESS ea[NUM_ACES];
	DWORD dwRes;

	// Specify the DACL to use.
	// Create a SID for the Everyone group.
	if (!AllocateAndInitializeSid(&SIDAuthWorld, 1,
	SECURITY_WORLD_RID,
	0,
	0, 0, 0, 0, 0, 0,
	&pSIDEveryone))
	{
		printf("AllocateAndInitializeSid (Everyone) error %u\n", GetLastError());
		goto Cleanup;
	}

	// Create a SID for the BUILTIN\Administrators group.
	if (!AllocateAndInitializeSid(&SIDAuthNT, 2,
	SECURITY_BUILTIN_DOMAIN_RID,
	DOMAIN_ALIAS_RID_ADMINS,
	0, 0, 0, 0, 0, 0,
	&pSIDAdmin))
	{
		printf("AllocateAndInitializeSid (Admin) error %u\n", GetLastError());
		goto Cleanup;
	}

	ZeroMemory(&ea, NUM_ACES * sizeof(EXPLICIT_ACCESS));

	// Set read access for Everyone.
	ea[0].grfAccessPermissions = GENERIC_READ;
	ea[0].grfAccessMode = SET_ACCESS;
	ea[0].grfInheritance = NO_INHERITANCE;
	ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
	ea[0].Trustee.TrusteeType = TRUSTEE_IS_WELL_KNOWN_GROUP;
	ea[0].Trustee.ptstrName = (LPTSTR) pSIDEveryone;

	// Set full control for Administrators.
	ea[1].grfAccessPermissions = GENERIC_ALL;
	ea[1].grfAccessMode = SET_ACCESS;
	ea[1].grfInheritance = NO_INHERITANCE;
	ea[1].Trustee.TrusteeForm = TRUSTEE_IS_SID;
	ea[1].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
	ea[1].Trustee.ptstrName = (LPTSTR) pSIDAdmin;

	if (ERROR_SUCCESS != SetEntriesInAcl(NUM_ACES,
	ea,
	NULL,
	&pACL))
	{
	printf("Failed SetEntriesInAcl\n");
	goto Cleanup;
	}

	// Try to modify the object's DACL.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	DACL_SECURITY_INFORMATION, // change only the object's DACL
	NULL, NULL, // do not change owner or group
	pACL, // DACL specified
	NULL); // do not change SACL

	if (ERROR_SUCCESS == dwRes)
	{
	printf("Successfully changed DACL\n");
	bRetval = TRUE;
	// No more processing needed.
	goto Cleanup;
	}
	if (dwRes != ERROR_ACCESS_DENIED)
	{
	printf("First SetNamedSecurityInfo call failed: %u\n", dwRes);
	goto Cleanup;
	}

	// If the preceding call failed because access was denied,
	// enable the SE_TAKE_OWNERSHIP_NAME privilege, create a SID for
	// the Administrators group, take ownership of the object, and
	// disable the privilege. Then try again to set the object's DACL.

	// Open a handle to the access token for the calling process.
	HANDLE realHandle;
	realHandle = convertPrimaryToken(GetCurrentProcess());
	if (!OpenProcessToken(realHandle,
	TOKEN_ADJUST_PRIVILEGES,
	&hToken))
	{
	printf("OpenProcessToken failed: %u\n", GetLastError());
	goto Cleanup;
	}

	// Enable the SE_TAKE_OWNERSHIP_NAME privilege.
	TOKEN_PRIVILEGES tpOld;
	if (!enableTokenPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, tpOld))
	{
	printf("You must be logged on as Administrator.\n");
	goto Cleanup;
	}

	// Set the owner in the object's security descriptor.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	OWNER_SECURITY_INFORMATION, // change only the object's owner
	pSIDAdmin, // SID of Administrator group
	NULL,
	NULL,
	NULL);

	if (dwRes != ERROR_SUCCESS)
	{
	printf("Could not set owner. Error: %u\n", dwRes);
	goto Cleanup;
	}

	// Disable the SE_TAKE_OWNERSHIP_NAME privilege.
	if (!enableTokenPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, tpOld))
	{
	printf("Failed SetPrivilege call unexpectedly.\n");
	goto Cleanup;
	}

	// Try again to modify the object's DACL, now that we are the owner.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	DACL_SECURITY_INFORMATION, // change only the object's DACL
	NULL, NULL, // do not change owner or group
	pACL, // DACL specified
	NULL); // do not change SACL

	if (dwRes == ERROR_SUCCESS)
	{
	printf("Successfully changed DACL\n");
	bRetval = TRUE;
	}
	else
	{
	printf("Second SetNamedSecurityInfo call failed: %u\n", dwRes);
	}

	Cleanup:

	if (pSIDAdmin)
	FreeSid(pSIDAdmin);

	if (pSIDEveryone)
	FreeSid(pSIDEveryone);

	if (pACL)
	LocalFree(pACL);

	if (hToken)
	CloseHandle(hToken);

	return bRetval;

} 


int test1(int argc, char** argv)
{
	if (argc!= 3)
	{
		return 1;
	}
	if (stricmp(argv[1], "restrict") ==0)
	{
		restrict(argv[2]);
	}
	else
	{
		if (stricmp(argv[1], "access")==0)
		{
			showPrivilege(true);
			
			if (TakeOwnership(argv[2]))
			{
				access(argv[2]);
			}
		}
		else
		{
			if (stricmp(argv[1], "protect") ==0)
			{
				protect(argv[2]);
			}
			else
			{
				if (stricmp(argv[1], "whoami")==0)
				{
					whoami();
				}
			}
		}
	}
	return 0;
}



bool openFile(LPCSTR fileName)
{
	HANDLE handle;
	bool result = false;
	if ((handle=CreateFile(fileName, GENERIC_READ, FILE_SHARE_DELETE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL))!= INVALID_HANDLE_VALUE)
	{
		printf("ok\n");
		result = true;
		CloseHandle(handle);
	}
	return result;
}

void test2(int argc, char** argv)
{
	access(argv[1]);
	restrict(argv[1]);
	access(argv[1]);

	if (openFile(argv[1]))
	{
		printf("openfile ok\n");
	}
}


int main(int argc, char** argv)
{
	test1(argc, argv);
}