
#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <Aclapi.h>
#include <lm.h>
#include <LMAccess.h>
#include <Ntsecapi.h>
#include <subauth.h>



#pragma comment(lib, "Netapi32.lib")

DWORD FullRights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;

bool displayToken(HANDLE htok, bool toEnable = false);



bool getSidFromAccount(LPTSTR userName, PSID* ppSid)
{
	SID_NAME_USE snu;
	TCHAR domainBuffer[MAX_PATH];
	DWORD sidSize =0, domainSize = MAX_PATH;
	bool result =false;

	if (!LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu) && GetLastError() == ERROR_INSUFFICIENT_BUFFER)
	{
		if ((*ppSid = LocalAlloc(LPTR, sidSize))!= NULL)
		{
			if (LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu))
			{
				result = true;
			}
		}		
	}
	return result;
}


bool createUserSD(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSD)
{
	PSID pOwnerSid;
	PACL  pDAcl;
	DWORD rights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;
	bool result = false;
	if (getSidFromAccount(userName, &pOwnerSid))
	{
		printf("ownersid\n");
		if ((pDAcl = (PACL)LocalAlloc(LPTR, 1024))!=NULL)
		{
			if (InitializeAcl(pDAcl, 1024, ACL_REVISION))
			{
				if (AddAccessAllowedAce(pDAcl, ACL_REVISION, rights, pOwnerSid))
				{
					printf("addaccessallowedace\n");
					//if (getSidFromAccount(_T("administrator"), &pCurrentSid))
					{
						//if (AddAccessAllowedAce(pDAcl, ACL_REVISION, WRITE_OWNER|WRITE_DAC|FILE_WRITE_DATA|DELETE, pCurrentSid))
						{
							if ((*ppSD = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, 1024))!=NULL)
							{
								if (InitializeSecurityDescriptor(*ppSD, SECURITY_DESCRIPTOR_REVISION))
								{
									if (SetSecurityDescriptorOwner(*ppSD, pOwnerSid, FALSE))
									{
										printf("setsecurityowner\n");
										if (SetSecurityDescriptorDacl(*ppSD, TRUE, pDAcl, FALSE))
										{
											printf("setdacl\n");
											result = true;
										}
									}
								}
							}
						}
					}
				}
			}
			//LocalFree(pDAcl);
		}
	}
	return result;
}

HANDLE convertPrimaryToken(HANDLE pseudoHandle)
{
	HANDLE handle = NULL;;
	DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &handle, DUPLICATE_SAME_ACCESS, FALSE, DUPLICATE_SAME_ACCESS);
	return handle;
}


// Useful helper function for enabling a single privilege
bool enableTokenPrivilege(HANDLE htok, LPCTSTR szPrivilege, TOKEN_PRIVILEGES& tpOld)
{
	bool result = false;
    TOKEN_PRIVILEGES tp;
    tp.PrivilegeCount = 1;
	DWORD cbOld;
	int err;
    tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
    if (LookupPrivilegeValue(NULL, szPrivilege, &tp.Privileges[0].Luid))
    {
        // htok must have been opened with the following permissions:
        // TOKEN_QUERY (to get the old priv setting)
        // TOKEN_ADJUST_PRIVILEGES (to adjust the priv)
        cbOld = sizeof(TOKEN_PRIVILEGES);
        if (AdjustTokenPrivileges(htok, FALSE, &tp, cbOld, &tpOld, &cbOld))
            // Note that AdjustTokenPrivileges may succeed, and yet
            // some privileges weren't actually adjusted.
            // You've got to check GetLastError() to be sure!
		{
			err = GetLastError();
            result = (ERROR_NOT_ALL_ASSIGNED != err);
			if (result)
			{
			
			}
		}        
    }
	return result;
}


bool displayToken(HANDLE htok, bool toEnable)
{
	bool result = false, enable;
	LPBYTE buffer[1024];
	DWORD bufferSize = 1024;
	TCHAR nameBuffer[256];
	DWORD nameBufferSize;
	TOKEN_PRIVILEGES tpOld;
	PTOKEN_PRIVILEGES ptp = (PTOKEN_PRIVILEGES)buffer;
	if (GetTokenInformation(htok, TokenPrivileges, buffer, bufferSize, &bufferSize))
	{
		for (int i=0; i<ptp->PrivilegeCount; i++)
		{
			nameBufferSize = 256;
			if (LookupPrivilegeName(NULL, &ptp->Privileges[i].Luid, nameBuffer, &nameBufferSize))
			{
				enable = toEnable;
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED)
				{				
					enable = false;
					_tprintf(_T("[enabled]"));
				}
				if (ptp->Privileges[i].Attributes  & SE_PRIVILEGE_USED_FOR_ACCESS)
				{
					enable = false;
					_tprintf(_T("[access]"));
				}
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED_BY_DEFAULT)
				{
					enable = false;
					_tprintf(_T("[default]"));								
				}
				if (ptp->Privileges[i].Attributes &SE_PRIVILEGE_REMOVED)
				{
					enable = false;
					_tprintf(_T("[removed]"));
				}
				if (enable)
				{
					if (enableTokenPrivilege(htok, nameBuffer, tpOld))
					{
						_tprintf(_T("enabled by me..."));
					}
				}


				_tprintf(_T(" [%s]\n"), nameBuffer);
				result = true;
			
			}
			else
			{
				int err  = GetLastError();
			}
		}
	}
	return result;
}

bool adjustOwnerPrivilege()
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	TOKEN_PRIVILEGES tpOld;
	bool result = false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{
		// TOKEN_ALL_ACCESSTOKEN_QUERY|TOKEN_ADJUST_PRIVILEGES
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{	
			displayToken(hToken, true);
			result = true;
		}
		else
		{
			int err = GetLastError();
		}
	}
	displayToken(hToken);
	return result;
}

bool deleteUser(LPTSTR userName)
{
	NET_API_STATUS nStatus;
    nStatus = NetUserDel(NULL,  userName);
	return nStatus == NERR_Success;
}
bool createUser(LPTSTR userName, LPTSTR password, LPTSTR server)
{
	NET_API_STATUS result;
	DWORD err = 0, length;
	USER_INFO_4 ui4;
	USER_INFO_1005 ui5;
	ZeroMemory(&ui4, sizeof(USER_INFO_4));
	ui4.usri4_name  = userName;
	ui4.usri4_password   = password;
	ui4.usri4_flags  = UF_PASSWD_CANT_CHANGE|UF_DONT_EXPIRE_PASSWD|UF_DONT_REQUIRE_PREAUTH|UF_TRUSTED_FOR_DELEGATION|UF_NORMAL_ACCOUNT;
	ui4.usri4_logon_server  = server;
	ui4.usri4_acct_expires  = TIMEQ_FOREVER ;
	ui4.usri4_max_storage  =  USER_MAXSTORAGE_UNLIMITED ;
	ui4.usri4_primary_group_id  = DOMAIN_GROUP_RID_USERS ;
	if ((result=NetUserAdd(NULL, 4, (LPBYTE)&ui4, &err)) == NERR_Success)
	{
		ui5.usri1005_priv = USER_PRIV_ADMIN;
		length = sizeof(USER_INFO_1005);
		{
			GROUP_USERS_INFO_0 gui0;
			gui0.grui0_name = _T("administrators");
			{
				return true;
			}
		}
	}
	else
	{
		switch (result)
		{
		case ERROR_ACCESS_DENIED:
			break;
		case NERR_NotPrimary:
			break;
		case NERR_UserExists:
			break;
		case NERR_PasswordTooShort :
			break;
		}
		return false;
	}
}
void createFileWithUserAccessOnly(LPTSTR fileName, LPTSTR userName, LPTSTR passWord)
{
	HANDLE fileHandle;
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = TRUE; 
	DWORD bytesWritten;
	char buffer[256];
	BOOL bPresent = TRUE, bDefault = TRUE;
	DWORD bufferSizeRequested = 0;
	TCHAR domainName[256];

	if (adjustOwnerPrivilege())
	{
		if (deleteUser(userName))
		{
			_tprintf(L"delete user %s ok\n", userName);
		}
		printf("before create user\n\n");
		if (createUser(userName, passWord, domainName))
		{
			_tprintf(L"create user %s ok\n", userName);
		if (createUserSD(userName, &sa.lpSecurityDescriptor))
		{ 
			if ((fileHandle =CreateFile(fileName, GENERIC_ALL, FILE_SHARE_DELETE, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))
				!= INVALID_HANDLE_VALUE)
			{
				for (int i=0; i<256; i++)
				{
					buffer[i]= i;
				}
				if (WriteFile(fileHandle, buffer, 256, &bytesWritten, NULL) && bytesWritten ==256)
				{
					printf("ok\n");
				}
			
				CloseHandle(fileHandle);
			}
			else
			{
				int err = GetLastError();
			}
		} 
	}
}
}


int _tmain(int argc, LPTSTR* argv)
{
	LPTSTR passWord = _T("123456");
	createFileWithUserAccessOnly(argv[1], argv[2], passWord);
	return 0;
}
