#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <Aclapi.h>
#include <lm.h>
#include <LMAccess.h>
#include <Ntsecapi.h>
#include <subauth.h>



#pragma comment(lib, "Netapi32.lib")


DWORD FullRights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;




bool getSidFromAccount(LPTSTR userName, PSID* pSid);

HANDLE myLogonUser(LPTSTR userName, LPTSTR passWord);

bool displayToken(HANDLE htok, bool toEnable = false);

HANDLE getRealHandle();


DWORD calcAclSize(PSID pSid)
{
	DWORD result = sizeof(ACL); // the header of ACL

	result += sizeof(ACE_HEADER)+ sizeof(DWORD);
	result += GetLengthSid(pSid);

	return result;
}


bool createUser(LPTSTR userName, LPTSTR password, LPTSTR server)
{
	//SE_INTERACTIVE_LOGON_NAME
	NET_API_STATUS result;
	DWORD err = 0, length;
	USER_INFO_4 ui4;
	USER_INFO_1005 ui5;
	ZeroMemory(&ui4, sizeof(USER_INFO_4));
	ui4.usri4_name  = userName;
	ui4.usri4_password   = password;
	ui4.usri4_flags  = UF_PASSWD_CANT_CHANGE|UF_DONT_EXPIRE_PASSWD|UF_DONT_REQUIRE_PREAUTH|UF_TRUSTED_FOR_DELEGATION|UF_NORMAL_ACCOUNT;
	ui4.usri4_logon_server  = server;
	ui4.usri4_acct_expires  = TIMEQ_FOREVER ;
	ui4.usri4_max_storage  =  USER_MAXSTORAGE_UNLIMITED ;
	ui4.usri4_primary_group_id  = DOMAIN_GROUP_RID_USERS ;

	if ((result=NetUserAdd(NULL, 4, (LPBYTE)&ui4, &err)) == NERR_Success)
	{
		ui5.usri1005_priv = USER_PRIV_ADMIN;
		length = sizeof(USER_INFO_1005);
		//if ((result = NetUserSetInfo(NULL, userName, 1005, (LPBYTE)&ui5, &length))== NERR_Success)
		{
			GROUP_USERS_INFO_0 gui0;
			gui0.grui0_name = _T("administrators");
			//if ((result = NetLocalGroupAddMembers(serverName, _ userName, 0, (LPBYTE)&gui0, 1)) ==NERR_Success)
			{
				return true;
			}
		}
	}
	else
	{
		switch (result)
		{
		case ERROR_ACCESS_DENIED:
			break;
		case NERR_NotPrimary:
			break;
		case NERR_UserExists:
			break;
		case NERR_PasswordTooShort :
			break;
		}
		return false;
	}
}



bool deleteUser(LPTSTR userName)
{
	NET_API_STATUS nStatus;
    nStatus = NetUserDel(NULL,  userName);
	return nStatus == NERR_Success;

}


bool getSdFromAccount(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd)
{
	bool result = false;
	HANDLE realHandle;
	if ((realHandle = getRealHandle())!= NULL)
	{
		if (GetSecurityInfo(realHandle, SE_KERNEL_OBJECT, 0, NULL, NULL, NULL, NULL, ppSd)==ERROR_SUCCESS)
		{
			result = true;
		}
	}
	return result;
}

bool getSidFromAccount(LPTSTR userName, PSID* ppSid)
{
	SID_NAME_USE snu;
	TCHAR domainBuffer[MAX_PATH];
	DWORD sidSize =0, domainSize = MAX_PATH;
	bool result =false;

	if (!LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu) && GetLastError() == ERROR_INSUFFICIENT_BUFFER)
	{
		if ((*ppSid = LocalAlloc(LPTR, sidSize))!= NULL)
		{
			if (LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu))
			{
				result = true;
			}
		}		
	}
	return result;
}


bool enableTokenPrivilege(HANDLE htok, LPCTSTR szPrivilege, TOKEN_PRIVILEGES& tpOld)
{
	bool result = false;
    TOKEN_PRIVILEGES tp;
    tp.PrivilegeCount = 1;
	DWORD cbOld;
	int err;
    tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
    if (LookupPrivilegeValue(NULL, szPrivilege, &tp.Privileges[0].Luid))
    {
        // htok must have been opened with the following permissions:
        // TOKEN_QUERY (to get the old priv setting)
        // TOKEN_ADJUST_PRIVILEGES (to adjust the priv)
        cbOld = sizeof(TOKEN_PRIVILEGES);
        if (AdjustTokenPrivileges(htok, FALSE, &tp, cbOld, &tpOld, &cbOld))
            // Note that AdjustTokenPrivileges may succeed, and yet
            // some privileges weren't actually adjusted.
            // You've got to check GetLastError() to be sure!
		{
			err = GetLastError();
            result = (ERROR_NOT_ALL_ASSIGNED != err);
			if (result)
			{
			
			}
		}        
    }
	return result;
}


HANDLE getRealHandle()
{
	HANDLE result = NULL;
	HANDLE pseudoHandle;
	pseudoHandle = GetCurrentProcess();
	if (DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &result, DUPLICATE_SAME_ACCESS, TRUE, 0))
	{
		return result;
	}
	return NULL;
}


HANDLE convertPrimaryToken(HANDLE pseudoHandle)
{
	HANDLE handle = NULL;;
	DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &handle, DUPLICATE_SAME_ACCESS, FALSE, DUPLICATE_SAME_ACCESS);
	return handle;
}

bool adjustOwnerPrivilege()
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	bool result = false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{
		// TOKEN_ALL_ACCESSTOKEN_QUERY|TOKEN_ADJUST_PRIVILEGES
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{	
			displayToken(hToken, true);
			result = true;
		}
		else
		{
			int err = GetLastError();
		}
	}
	displayToken(hToken);
	return result;
}




bool createEmptyUserSd(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd, PSID* ppSid)
{
	bool result =false;
	if (getSidFromAccount(userName, ppSid))
	{
		if ((*ppSd = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, SECURITY_DESCRIPTOR_MIN_LENGTH))!=NULL)
		{
			if (InitializeSecurityDescriptor(*ppSd, SECURITY_DESCRIPTOR_REVISION))
			{
				if (SetSecurityDescriptorOwner(*ppSd, *ppSid, FALSE))
				{
					result = true;
				}
			}
		}
	}
	return result;
}


bool createSingleDAcl(PACL* ppAcl, PSID pSid, DWORD mask, bool isAllowed)
{
	DWORD size;
	bool result =false;
	size = calcAclSize(pSid);

	if ((*ppAcl = (PACL)LocalAlloc(LPTR, size)) != NULL)
	{
		if (InitializeAcl(*ppAcl, size, ACL_REVISION))
		{
			if (isAllowed)
			{
				if (AddAccessAllowedAce(*ppAcl, ACL_REVISION, FullRights, pSid))
				{
					result = true;
				}
				else
				{
					printf("error of addacclessallowedace %d\n", GetLastError());
				}
			}
			else
			{
				if (AddAccessDeniedAce(*ppAcl, ACL_REVISION, FullRights, pSid))
				{
					result = true;
				}
			}
		}
	}
	return result;
}

bool createUserExclusiveSd(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd)
{
	PSID pSid;
	PACL  pDAcl;
	
	bool result = false;
	if (createEmptyUserSd(userName, ppSd, &pSid))
	{	
		if (createSingleDAcl(&pDAcl, pSid, FullRights, true))
		{
			if (SetSecurityDescriptorOwner(*ppSd, pSid, FALSE))
			{				
				if (SetSecurityDescriptorDacl(*ppSd, TRUE, pDAcl, FALSE))
				{					
					result = true;
				}
			}		
		}
	}
	return result;
}


bool createUserSD(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSD)
{
	PSID pOwnerSid;
	PACL  pDAcl;
	DWORD rights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;
	bool result = false;
	if (getSidFromAccount(userName, &pOwnerSid))
	{
		printf("ownersid\n");
		if ((pDAcl = (PACL)LocalAlloc(LPTR, 1024))!=NULL)
		{
			if (InitializeAcl(pDAcl, 1024, ACL_REVISION))
			{
				if (AddAccessAllowedAce(pDAcl, ACL_REVISION, rights, pOwnerSid))
				{
					printf("addaccessallowedace\n");
					//if (getSidFromAccount(_T("administrator"), &pCurrentSid))
					{
						//if (AddAccessAllowedAce(pDAcl, ACL_REVISION, WRITE_OWNER|WRITE_DAC|FILE_WRITE_DATA|DELETE, pCurrentSid))
						{
							if ((*ppSD = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, 1024))!=NULL)
							{
								if (InitializeSecurityDescriptor(*ppSD, SECURITY_DESCRIPTOR_REVISION))
								{
									if (SetSecurityDescriptorOwner(*ppSD, pOwnerSid, FALSE))
									{
										printf("setsecurityowner\n");
										if (SetSecurityDescriptorDacl(*ppSD, TRUE, pDAcl, FALSE))
										{
											printf("setdacl\n");
											result = true;
										}
									}
								}
							}
						}
					}
				}
			}
			//LocalFree(pDAcl);
		}
	}
	return result;
}


bool getSdFromFile(LPTSTR fileName, PSECURITY_DESCRIPTOR* ppSd)
{
	bool result = false;
	DWORD size= 1024;
	if ((*ppSd = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, size))!=NULL)
	{
		if (GetFileSecurity(fileName, OWNER_SECURITY_INFORMATION, *ppSd, size, &size) && size > 0)
		{		
			result = true;		
		}
		else
		{
			printf("error %d\n", GetLastError());
		}
	}
	return result;
}

bool myHeapAlloc(LPVOID* ptr, DWORD size)
{
	if ((*ptr = HeapAlloc(GetProcessHeap(), 0, size))!= NULL)
	{
		return true;
	}
	return false;
}

bool myMakeAbsoluteSD(PSECURITY_DESCRIPTOR pSrcSD, PSECURITY_DESCRIPTOR* pDstSD)
{
	bool result = false;
	PACL pDAcl, pSAcl;
	PSID pOwner, pGroup;
	DWORD sdSize = 0, daclSize = 0, saclSize = 0, ownerSize = 0, groupSize = 0;
	if  (!MakeAbsoluteSD(pSrcSD, *pDstSD, &sdSize, pDAcl, &daclSize, pSAcl, &saclSize, pOwner, &ownerSize, pGroup, &groupSize))
	{	
		if (myHeapAlloc(pDstSD, sdSize))
		{	
			if (myHeapAlloc((LPVOID*)&pSAcl, saclSize))
			{		
				if (myHeapAlloc((LPVOID*)&pDAcl, daclSize))
				{		
					if (myHeapAlloc((LPVOID*)&pOwner, ownerSize))
					{		
						if (myHeapAlloc((LPVOID*)&pGroup, groupSize))
						{
							if (MakeAbsoluteSD(pSrcSD, *pDstSD, &sdSize, pDAcl, &daclSize, pSAcl, &saclSize, pOwner, &ownerSize, pGroup, &groupSize))
							{
								result = true;
							}
						}
					}					
				}
			}
		}
	}
	return result;
}

bool changeFileOwner(LPTSTR fileName, LPTSTR userName)
{
	bool result = false;
	PSID pSid;
	PSECURITY_DESCRIPTOR pSd, pDstSd;
	if (adjustOwnerPrivilege())
	{	
		if (getSdFromFile(fileName, &pSd))
		{
			if (getSidFromAccount(userName, &pSid))
			{
				if (myMakeAbsoluteSD(pSd, &pDstSd))
				{
					if (SetSecurityDescriptorOwner(pSd, pSid, FALSE))
					{						
						if (SetFileSecurity(fileName, OWNER_SECURITY_INFORMATION, pDstSd))
						{
							result = true;
						}
					}
				}
				else
				{
					printf("errror %d\n", GetLastError());
				}
			}
		}	
	}
	return result;
}



HANDLE myConvertPrimaryToken(HANDLE hToken)
{
	HANDLE hPrimary = NULL;
	if (DuplicateTokenEx(hToken, TOKEN_ALL_ACCESS, NULL, SecurityImpersonation, TokenPrimary, &hPrimary))
	{
	}
	return hPrimary;
}




bool displayToken(HANDLE htok, bool toEnable)
{
	bool result = false, enable;
	LPBYTE buffer[1024];
	DWORD bufferSize = 1024;
	TCHAR nameBuffer[256];
	DWORD nameBufferSize;
	TOKEN_PRIVILEGES tpOld;
	PTOKEN_PRIVILEGES ptp = (PTOKEN_PRIVILEGES)buffer;
	if (GetTokenInformation(htok, TokenPrivileges, buffer, bufferSize, &bufferSize))
	{
		for (int i=0; i<ptp->PrivilegeCount; i++)
		{
			nameBufferSize = 256;
			if (LookupPrivilegeName(NULL, &ptp->Privileges[i].Luid, nameBuffer, &nameBufferSize))
			{
				enable = toEnable;
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED)
				{				
					enable = false;
					_tprintf(_T("[enabled]"));
				}
				if (ptp->Privileges[i].Attributes  & SE_PRIVILEGE_USED_FOR_ACCESS)
				{
					enable = false;
					_tprintf(_T("[access]"));
				}
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED_BY_DEFAULT)
				{
					enable = false;
					_tprintf(_T("[default]"));								
				}
				if (ptp->Privileges[i].Attributes &SE_PRIVILEGE_REMOVED)
				{
					enable = false;
					_tprintf(_T("[removed]"));
				}
				if (enable)
				{
					if (enableTokenPrivilege(htok, nameBuffer, tpOld))
					{
						_tprintf(_T("enabled by me..."));
					}
				}


				_tprintf(_T(" [%s]\n"), nameBuffer);
				result = true;
			
			}
			else
			{
				int err  = GetLastError();
			}
		}
	}
	return result;
}


bool getAccountDomain(LPTSTR userName, LPTSTR domainName)
{
	bool result = false;
	SID_NAME_USE snu;
	DWORD domainNameSize = MAX_PATH, sidSize = 1024;
	LPBYTE sidBuffer[1024];
	if (LookupAccountName(NULL, userName, sidBuffer, &sidSize, domainName, &domainNameSize, &snu))
	{
		result = true;
	}
	return result;
}


bool openFileWithUserProgramTest(LPTSTR fileName, LPTSTR userName, LPTSTR domainName, LPTSTR passWord, LPTSTR programName)
{
	TCHAR commandLine[1024];
	TCHAR programNameBuffer[1024];
	bool result = false;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	LPTSTR ptr;
	TCHAR userNameBuffer[MAX_PATH];
	HANDLE hToken, hPrimary;

	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	
	if (GetModuleFileName(NULL, programNameBuffer, 1024))
	{
		if ((ptr = _tcsrchr(programNameBuffer, _T('\\')))!= NULL)
		{
			ptr ++;
			_tcscpy(ptr, programName);
			
			_stprintf(commandLine, _T("\"%s\" display \"%s\""), programNameBuffer, fileName);			
			printf("before createprocess\n\n");
			if (CreateProcessWithLogonW(userName, domainName, passWord, LOGON_WITH_PROFILE, NULL, commandLine, 0, NULL, NULL, &si, &pi))
			{
				WaitForSingleObject(pi.hProcess, INFINITE);					
				result = true;
			}
			else
			{
				int err = GetLastError();
				printf("create process error %d\n", err);
			}		
		}
	}
	return result;
}


void test101(int argc, LPTSTR* argv)
{
	LPTSTR userName = argv[1];
	LPTSTR fileName = argv[2];
	
	LPTSTR passWord = _T("123456");
	
	LPTSTR programName = _T("fileReader.exe");
	LPTSTR domainName = argv[3];
	



	
	if (openFileWithUserProgramTest(fileName, userName,  domainName, passWord, programName))
	{
		
		_tprintf(L"openFileWithUserProgramTest file=%s user=%s domain=%s password=%s program=%s\n", fileName, userName, domainName, passWord, programName);	
	}

}


int _tmain(int argc, LPTSTR* argv)
{

	test101(argc, argv);


	return 0;
}

