#define _WIN32_WINNT 0x0500

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
//#define INCL_NET
#include <Aclapi.h>
#include <lm.h>
#include <LMAccess.h>
#include <Ntsecapi.h>
#include <subauth.h>



#pragma comment(lib, "Netapi32.lib")

/*
The following example shows how to calculate the size of an access-allowed ACE:

sizeof (ACCESS_ALLOWED_ACE) - sizeof (ACCESS_ALLOWED_ACE.SidStart) 
        + GetLengthSid (pAceSid);
To calculate the size of an ACL, use the following algorithm, substituting the appropriate ACE structure in the sizeof(ACE) expression:

cbAcl = sizeof (ACL);
for (i = 0 ; i < nAceCount ; i++) {
    // subtract ACE.SidStart from the size
    cbAce = sizeof (ACE) - sizeof (DWORD);
    // add this ACE's SID length
    cbAce += GetLengthSid (pAceSid[i]);
    // add the length of each ACE to the total ACL length
    cbAcl += cbAce;
}
*/


DWORD FullRights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;



#define PASSWORD TEXT("nickhuang")

bool getSidFromAccount(LPTSTR userName, PSID* pSid);
HANDLE myLogonUser(LPTSTR userName, LPTSTR passWord);

bool displayToken(HANDLE htok, bool toEnable = false);

HANDLE getRealHandle();

#define TARGET_SYSTEM_NAME L"NICKHP"

DWORD calcAclSize(PSID* pSid, int sidCount)
{
	DWORD result = sizeof(ACL); // the header of ACL
	for (int i = 0; i < sidCount; i ++)
	{
		result += sizeof(ACE_HEADER) + sizeof(DWORD);
		result += GetLengthSid(pSid[i]);
	}
	return result;
}


DWORD calcAclSize(PSID pSid)
{
	DWORD result = sizeof(ACL); // the header of ACL

	result += sizeof(ACE_HEADER)+ sizeof(DWORD);
	result += GetLengthSid(pSid);

	return result;
}


LSA_HANDLE getPolicyHandle()
{
	LSA_OBJECT_ATTRIBUTES ObjectAttributes;
	WCHAR SystemName[] = TARGET_SYSTEM_NAME;
	USHORT SystemNameLength;
	LSA_UNICODE_STRING lusSystemName;
	NTSTATUS ntsResult;
	LSA_HANDLE lsahPolicyHandle;

	// Object attributes are reserved, so initialize to zeroes.
	ZeroMemory(&ObjectAttributes, sizeof(ObjectAttributes));

	//Initialize an LSA_UNICODE_STRING to the server name.
	SystemNameLength = wcslen(SystemName);
	lusSystemName.Buffer = SystemName;
	lusSystemName.Length = SystemNameLength * sizeof(WCHAR);
	lusSystemName.MaximumLength= (SystemNameLength+1) * sizeof(WCHAR);

	// Get a handle to the Policy object.
	ntsResult = LsaOpenPolicy(
	&lusSystemName,    //Name of the target system.
		&ObjectAttributes, 
		POLICY_ALL_ACCESS, //Desired access permissions.
		&lsahPolicyHandle  //Receives the policy handle.
	);

	if (ntsResult != STATUS_SUCCESS)
	{
		// An error occurred. Display it as a win32 error code.
		wprintf(L"OpenPolicy returned %lu\n",
		  LsaNtStatusToWinError(ntsResult));
		return NULL;
	} 
	return lsahPolicyHandle;
}




bool checkAccount(LPTSTR userName)
{
	LSA_HANDLE policyHandle;
	PLSA_UNICODE_STRING  plus;
	PSID pSid;
	bool result = false;
	DWORD count;
	NTSTATUS status;
	if ((policyHandle = getPolicyHandle())!=NULL)
	{
		if (getSidFromAccount(userName, &pSid))
		{
			if ((status = LsaEnumerateAccountRights(policyHandle, pSid, &plus, &count))== STATUS_SUCCESS)
			{
				for (int i = 0; i< count; i++)
				{
					_tprintf(_T("[%s]\n"), plus[i].Buffer);
				}
				result = true;				
			}
			else
			{
				int err = LsaNtStatusToWinError(status);
			}
			LsaFreeMemory(plus);
		}
	}
	return result;
}

bool enumWorkStationUser(LPTSTR serverName)
{
   LPWKSTA_USER_INFO_0 pBuf = NULL;
   LPWKSTA_USER_INFO_0 pTmpBuf;
   DWORD dwLevel = 0;
   DWORD dwEntriesRead = 0;
   DWORD dwTotalEntries = 0;
   DWORD dwResumeHandle = 0;
   DWORD i;
   DWORD dwTotalCount = 0;
   NET_API_STATUS nStatus;
   LPTSTR pszServerName = NULL;

     //
   // Call the NetWkstaUserEnum function, specifying level 0.
   //
   do // begin do
   {
      nStatus = NetWkstaUserEnum(serverName,
                                 0,
                                 (LPBYTE*)&pBuf,
                                 MAX_PREFERRED_LENGTH,
                                 &dwEntriesRead,
                                 &dwTotalEntries,
                                 &dwResumeHandle);
      //
      // If the call succeeds,
      //
      if ((nStatus == NERR_Success) || (nStatus == ERROR_MORE_DATA))
      {
         if ((pTmpBuf = pBuf) != NULL)
         {
            //
            // Loop through the entries.
            //
            for (i = 0; (i < dwEntriesRead); i++)
            {
               //assert(pTmpBuf != NULL);

               if (pTmpBuf == NULL)
               {
                  //
                  // Only members of the Administrators local group
                  //  can successfully execute NetWkstaUserEnum
                  //  locally and on a remote server.
                  //
                  fprintf(stderr, "An access violation has occurred\n");
                  break;
               }
               //
               // Print the user logged on to the workstation. 
               //
               wprintf(L"\t-- %s\n", pTmpBuf->wkui0_username);

               pTmpBuf++;
               dwTotalCount++;
            }
         }
      }
      //
      // Otherwise, indicate a system error.
      //
      else
	  {
         fprintf(stderr, "A system error has occurred: %d\n", nStatus);
	  }
      //
      // Free the allocated memory.
      //
      if (pBuf != NULL)
      {
         NetApiBufferFree(pBuf);
         pBuf = NULL;
      }
   }
   // 
   // Continue to call NetWkstaUserEnum while 
   //  there are more entries. 
   // 
   while (nStatus == ERROR_MORE_DATA); // end do
   //
   // Check again for allocated memory.
   //
   if (pBuf != NULL)
   {
      NetApiBufferFree(pBuf);
	}
   //
   // Print the final count of workstation users.
   //
   fprintf(stderr, "\nTotal of %d entries enumerated\n", dwTotalCount);

   return 0;
}



#if 1
bool createUser(LPTSTR userName, LPTSTR password, LPTSTR server)
{
	//SE_INTERACTIVE_LOGON_NAME
	NET_API_STATUS result;
	DWORD err = 0, length;
	USER_INFO_4 ui4;
	USER_INFO_1005 ui5;
	ZeroMemory(&ui4, sizeof(USER_INFO_4));
	ui4.usri4_name  = userName;
	ui4.usri4_password   = password;
	ui4.usri4_flags  = UF_PASSWD_CANT_CHANGE|UF_DONT_EXPIRE_PASSWD|UF_DONT_REQUIRE_PREAUTH|UF_TRUSTED_FOR_DELEGATION|UF_NORMAL_ACCOUNT;
	ui4.usri4_logon_server  = server;
	ui4.usri4_acct_expires  = TIMEQ_FOREVER ;
	ui4.usri4_max_storage  =  USER_MAXSTORAGE_UNLIMITED ;
	ui4.usri4_primary_group_id  = DOMAIN_GROUP_RID_USERS ;

	if ((result=NetUserAdd(NULL, 4, (LPBYTE)&ui4, &err)) == NERR_Success)
	{
		ui5.usri1005_priv = USER_PRIV_ADMIN;
		length = sizeof(USER_INFO_1005);
		//if ((result = NetUserSetInfo(NULL, userName, 1005, (LPBYTE)&ui5, &length))== NERR_Success)
		{
			GROUP_USERS_INFO_0 gui0;
			gui0.grui0_name = _T("administrators");
			//if ((result = NetLocalGroupAddMembers(serverName, _ userName, 0, (LPBYTE)&gui0, 1)) ==NERR_Success)
			{
				return true;
			}
		}
	}
	else
	{
		switch (result)
		{
		case ERROR_ACCESS_DENIED:
			break;
		case NERR_NotPrimary:
			break;
		case NERR_UserExists:
			break;
		case NERR_PasswordTooShort :
			break;
		}
		return false;
	}
}
#else
bool createUser(LPTSTR userName, LPTSTR password, LPTSTR server)
{
	//SE_INTERACTIVE_LOGON_NAME
	NET_API_STATUS result;
	DWORD err = 0, length;
	USER_INFO_2 ui2;
	
	ZeroMemory(&ui2, sizeof(USER_INFO_2));
	ui2.usri2_name  = userName;
	ui2.usri2_password  = password;
	ui2.usri2_flags  = UF_PASSWD_CANT_CHANGE|UF_DONT_EXPIRE_PASSWD|UF_DONT_REQUIRE_PREAUTH|UF_TRUSTED_FOR_DELEGATION|UF_NORMAL_ACCOUNT;
	ui2.usri2_logon_server = server;

	ui2.usri2_acct_expires  = TIMEQ_FOREVER ;
	ui2.usri2_max_storage =  USER_MAXSTORAGE_UNLIMITED ;

	if ((result=NetUserAdd(NULL, 2, (LPBYTE)&ui2, &err)) == NERR_Success)
	{
		{
			return true;
		}
	
	}
	else
	{
		switch (result)
		{
		case ERROR_ACCESS_DENIED:
			break;
		case NERR_NotPrimary:
			break;
		case NERR_UserExists:
			printf("exist\n");
			break;
		case NERR_PasswordTooShort :
			break;
		}
		printf("create user error %d\n", result);
		return false;
	}
}
#endif



bool addUsers(LPTSTR serverName, LPTSTR groupName, LPTSTR userName)
{
	NET_API_STATUS status;
	LOCALGROUP_MEMBERS_INFO_3 lmi3;
	TCHAR buffer[MAX_PATH];
	DWORD count =1;
	_stprintf(buffer, _T("%s\\%s"), serverName, userName);
	lmi3.lgrmi3_domainandname = buffer;
	if ((status = NetLocalGroupAddMembers(serverName, groupName, 3, (LPBYTE)&lmi3, count)) == NERR_Success)
	{
		return true;
	}
	return false;
}


bool checkUsers(LPTSTR serverName, LPTSTR userName)
{
	PLOCALGROUP_USERS_INFO_0 plgui0;
	DWORD count, total;
	PDWORD_PTR resumeHandle = NULL;
	NET_API_STATUS status;
	LPBYTE ptr;
	bool result = false;
	if ((status = NetUserGetLocalGroups(serverName, userName, 0, LG_INCLUDE_INDIRECT, (LPBYTE*)&plgui0,  MAX_PREFERRED_LENGTH, &count, &total)) == NERR_Success)
	{
		for (int i=0; i<count; i++)
		{
			_tprintf(_T("group [%s]\n"), plgui0[i].lgrui0_name);
		}
		result = true;

	}
	return result;
}


bool changePassword(LPTSTR userName, LPTSTR password)
{
	USER_INFO_1003 usriSetPassword;
	DWORD netRet = 0, err = 0;
	usriSetPassword.usri1003_password  = password;

	netRet = NetUserSetInfo(NULL, L"administrator",  1003, (LPBYTE)&usriSetPassword, &err);
	if( netRet == NERR_Success ) 
	{
		return true;
	}
	else 
	{
		printf("ERROR: %d Returned from NetUserSetInfo\n", netRet);
		return false;
	}
}

bool deleteUser(LPTSTR userName)
{
	NET_API_STATUS nStatus;
    nStatus = NetUserDel(NULL,  userName);
	return nStatus == NERR_Success;

}

bool getAccountDomain(LPTSTR userName, LPTSTR domainName)
{
	bool result = false;
	SID_NAME_USE snu;
	DWORD domainNameSize = MAX_PATH, sidSize = 1024;
	LPBYTE sidBuffer[1024];
	if (LookupAccountName(NULL, userName, sidBuffer, &sidSize, domainName, &domainNameSize, &snu))
	{
		result = true;
	}
	return result;
}

bool getSdFromAccount(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd)
{
	bool result = false;
	HANDLE realHandle;
	if ((realHandle = getRealHandle())!= NULL)
	{
		if (GetSecurityInfo(realHandle, SE_KERNEL_OBJECT, 0, NULL, NULL, NULL, NULL, ppSd)==ERROR_SUCCESS)
		{
			result = true;
		}
	}
	return result;
}

bool getSidFromAccount(LPTSTR userName, PSID* ppSid)
{
	SID_NAME_USE snu;
	TCHAR domainBuffer[MAX_PATH];
	DWORD sidSize =0, domainSize = MAX_PATH;
	bool result =false;

	if (!LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu) && GetLastError() == ERROR_INSUFFICIENT_BUFFER)
	{
		if ((*ppSid = LocalAlloc(LPTR, sidSize))!= NULL)
		{
			if (LookupAccountName(NULL, userName, *ppSid, &sidSize, domainBuffer, &domainSize, &snu))
			{
				result = true;
			}
		}		
	}
	return result;
}


// Useful helper function for enabling a single privilege
bool enableTokenPrivilege(HANDLE htok, LPCTSTR szPrivilege, TOKEN_PRIVILEGES& tpOld)
{
	bool result = false;
    TOKEN_PRIVILEGES tp;
    tp.PrivilegeCount = 1;
	DWORD cbOld;
	int err;
    tp.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	
    if (LookupPrivilegeValue(NULL, szPrivilege, &tp.Privileges[0].Luid))
    {
        // htok must have been opened with the following permissions:
        // TOKEN_QUERY (to get the old priv setting)
        // TOKEN_ADJUST_PRIVILEGES (to adjust the priv)
        cbOld = sizeof(TOKEN_PRIVILEGES);
        if (AdjustTokenPrivileges(htok, FALSE, &tp, cbOld, &tpOld, &cbOld))
            // Note that AdjustTokenPrivileges may succeed, and yet
            // some privileges weren't actually adjusted.
            // You've got to check GetLastError() to be sure!
		{
			err = GetLastError();
            result = (ERROR_NOT_ALL_ASSIGNED != err);
			if (result)
			{
			
			}
		}        
    }
	return result;
}


bool queryToken(HANDLE handle)
{
//GetKernelObjectSecurity(handle, DACL_SECURITY_INFORMATION,  
	return true;
}

HANDLE getRealHandle()
{
	HANDLE result = NULL;
	HANDLE pseudoHandle;
	pseudoHandle = GetCurrentProcess();
	if (DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &result, DUPLICATE_SAME_ACCESS, TRUE, 0))
	{
		return result;
	}
	return NULL;
}


HANDLE convertPrimaryToken(HANDLE pseudoHandle)
{
	HANDLE handle = NULL;;
	DuplicateHandle(pseudoHandle, pseudoHandle, pseudoHandle, &handle, DUPLICATE_SAME_ACCESS, FALSE, DUPLICATE_SAME_ACCESS);
	return handle;
}

#if 1	
bool adjustOwnerPrivilege()
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	TOKEN_PRIVILEGES tpOld;
	bool result = false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{
		// TOKEN_ALL_ACCESSTOKEN_QUERY|TOKEN_ADJUST_PRIVILEGES
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{	
			displayToken(hToken, true);
			result = true;
		}
		else
		{
			int err = GetLastError();
		}
	}
	displayToken(hToken);
	return result;
}
#else
bool adjustOwnerPrivilege()
{
	HANDLE handle, pseudoHandle;
	HANDLE hToken;
	TOKEN_PRIVILEGES tpOld;
	bool result = false;

	pseudoHandle = GetCurrentProcess();
	
	if ((handle = convertPrimaryToken(pseudoHandle))!= NULL)
	{
		// TOKEN_ALL_ACCESSTOKEN_QUERY|TOKEN_ADJUST_PRIVILEGES
		if (OpenProcessToken(handle, TOKEN_ALL_ACCESS, &hToken))
		{
			if (enableTokenPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, tpOld))
			{
				if (enableTokenPrivilege(hToken, SE_INCREASE_QUOTA_NAME, tpOld))	
				{
					if (enableTokenPrivilege(hToken, SE_TCB_NAME, tpOld))	
					{
						result = true;
					}
				}
			}
			displayToken(hToken);
		}
		else
		{
			int err = GetLastError();
		}

	}
	return result;
}
#endif
				
bool compareSidFromAccount(LPTSTR userName1, LPTSTR userName2)
{
	PSID pSid1, pSid2;
	bool result =false;
	if (getSidFromAccount(userName1, &pSid1))
	{
		if (getSidFromAccount(userName2, &pSid2))
		{
			if (EqualSid(pSid1, pSid2))
			{
				result = true;
			}
			LocalFree(pSid2);
		}
		LocalFree(pSid1);
	}
	return result;
}



#if 0
bool createEmptyUserSd(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd, PSID* ppSid)
{
	bool result =false;
	if (getSidFromAccount(userName, ppSid))
	{
		if ((*ppSd = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, SECURITY_DESCRIPTOR_MIN_LENGTH))!=NULL)
		{
			if (InitializeSecurityDescriptor(*ppSd, SECURITY_DESCRIPTOR_REVISION))
			{
				if (SetSecurityDescriptorOwner(*ppSd, *ppSid, FALSE))
				{
					result = true;
				}
			}
		}
	}
	return result;
}
#else
bool createEmptyUserSd(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd, PSID* ppSid)
{
	bool result =false;
	if (getSidFromAccount(userName, ppSid))
	{
		if ((*ppSd = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, SECURITY_DESCRIPTOR_MIN_LENGTH))!=NULL)
		{
			if (InitializeSecurityDescriptor(*ppSd, SECURITY_DESCRIPTOR_REVISION))
			{
				if (SetSecurityDescriptorOwner(*ppSd, *ppSid, FALSE))
				{
					result = true;
				}
			}
		}
	}
	return result;
}
#endif

bool createSingleDAcl(PACL* ppAcl, PSID pSid, DWORD mask, bool isAllowed)
{
	DWORD size;
	bool result =false;
	size = calcAclSize(pSid);

	if ((*ppAcl = (PACL)LocalAlloc(LPTR, size)) != NULL)
	{
		if (InitializeAcl(*ppAcl, size, ACL_REVISION))
		{
			if (isAllowed)
			{
				if (AddAccessAllowedAce(*ppAcl, ACL_REVISION, FullRights, pSid))
				{
					result = true;
				}
				else
				{
					printf("error of addacclessallowedace %d\n", GetLastError());
				}
			}
			else
			{
				if (AddAccessDeniedAce(*ppAcl, ACL_REVISION, FullRights, pSid))
				{
					result = true;
				}
			}
		}
	}
	return result;
}

bool createUserExclusiveSd(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSd)
{
	PSID pSid;
	PACL  pDAcl;
	
	bool result = false;
	if (createEmptyUserSd(userName, ppSd, &pSid))
	{	
		if (createSingleDAcl(&pDAcl, pSid, FullRights, true))
		{
			if (SetSecurityDescriptorOwner(*ppSd, pSid, FALSE))
			{				
				if (SetSecurityDescriptorDacl(*ppSd, TRUE, pDAcl, FALSE))
				{					
					result = true;
				}
			}		
		}
	}
	return result;
}


#if 0
bool createUserSD(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSD)
{
	PSID pSid;
	//PSID pCurrentSid;
	PACL  pDAcl;
	DWORD rights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;
	bool result = false;
	if (createEmptyUserSd(userName, ppSD, &pSid))
	{
		if ((pDAcl = (PACL)LocalAlloc(LPTR, 1024))!=NULL)
		{
			if (InitializeAcl(pDAcl, 1024, ACL_REVISION))
			{
				if (AddAccessAllowedAce(pDAcl, ACL_REVISION, rights, *ppSD))
				{
					printf("addaccessallowedace\n");
					//if (getSidFromAccount(_T("administrator"), &pCurrentSid))
					{
						//if (AddAccessAllowedAce(pDAcl, ACL_REVISION, WRITE_OWNER|WRITE_DAC|FILE_WRITE_DATA|DELETE, pCurrentSid))
						{
							if ((*ppSD = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, 1024))!=NULL)
							{
								//if (InitializeSecurityDescriptor(*ppSD, SECURITY_DESCRIPTOR_REVISION))
								{
									//if (SetSecurityDescriptorOwner(*ppSD, pOwnerSid, FALSE))
									{
										printf("setsecurityowner\n");
										if (SetSecurityDescriptorDacl(*ppSD, TRUE, pDAcl, FALSE))
										{
											printf("setdacl\n");
											result = true;
										}
									}
								}
							}
						}
					}
				}
			}
			//LocalFree(pDAcl);
		}
	}
	return result;
}
#else
bool createUserSD(LPTSTR userName, PSECURITY_DESCRIPTOR* ppSD)
{
	PSID pOwnerSid;
	PACL  pDAcl;
	DWORD rights = SPECIFIC_RIGHTS_ALL|STANDARD_RIGHTS_ALL|GENERIC_READ|GENERIC_WRITE|GENERIC_EXECUTE|GENERIC_ALL|MAXIMUM_ALLOWED|ACCESS_SYSTEM_SECURITY;
	bool result = false;
	if (getSidFromAccount(userName, &pOwnerSid))
	{
		printf("ownersid\n");
		if ((pDAcl = (PACL)LocalAlloc(LPTR, 1024))!=NULL)
		{
			if (InitializeAcl(pDAcl, 1024, ACL_REVISION))
			{
				if (AddAccessAllowedAce(pDAcl, ACL_REVISION, rights, pOwnerSid))
				{
					printf("addaccessallowedace\n");
					//if (getSidFromAccount(_T("administrator"), &pCurrentSid))
					{
						//if (AddAccessAllowedAce(pDAcl, ACL_REVISION, WRITE_OWNER|WRITE_DAC|FILE_WRITE_DATA|DELETE, pCurrentSid))
						{
							if ((*ppSD = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, 1024))!=NULL)
							{
								if (InitializeSecurityDescriptor(*ppSD, SECURITY_DESCRIPTOR_REVISION))
								{
									if (SetSecurityDescriptorOwner(*ppSD, pOwnerSid, FALSE))
									{
										printf("setsecurityowner\n");
										if (SetSecurityDescriptorDacl(*ppSD, TRUE, pDAcl, FALSE))
										{
											printf("setdacl\n");
											result = true;
										}
									}
								}
							}
						}
					}
				}
			}
			//LocalFree(pDAcl);
		}
	}
	return result;
}
#endif


//bool changeSecurityDescriptorOwner(PSECURITY_DESCRIPTOR


bool getSdFromFile(LPTSTR fileName, PSECURITY_DESCRIPTOR* ppSd)
{
	bool result = false;
	DWORD size= 1024;
	if ((*ppSd = (PSECURITY_DESCRIPTOR)LocalAlloc(LPTR, size))!=NULL)
	{
		if (GetFileSecurity(fileName, OWNER_SECURITY_INFORMATION, *ppSd, size, &size) && size > 0)
		{		
			result = true;		
		}
		else
		{
			printf("error %d\n", GetLastError());
		}
	}
	return result;
}

bool myHeapAlloc(LPVOID* ptr, DWORD size)
{
	if ((*ptr = HeapAlloc(GetProcessHeap(), 0, size))!= NULL)
	{
		return true;
	}
	return false;
}

bool myMakeAbsoluteSD(PSECURITY_DESCRIPTOR pSrcSD, PSECURITY_DESCRIPTOR* pDstSD)
{
	bool result = false;
	PACL pDAcl, pSAcl;
	PSID pOwner, pGroup;
	DWORD sdSize = 0, daclSize = 0, saclSize = 0, ownerSize = 0, groupSize = 0;
	if  (!MakeAbsoluteSD(pSrcSD, *pDstSD, &sdSize, pDAcl, &daclSize, pSAcl, &saclSize, pOwner, &ownerSize, pGroup, &groupSize))
	{	
		if (myHeapAlloc(pDstSD, sdSize))
		{	
			if (myHeapAlloc((LPVOID*)&pSAcl, saclSize))
			{		
				if (myHeapAlloc((LPVOID*)&pDAcl, daclSize))
				{		
					if (myHeapAlloc((LPVOID*)&pOwner, ownerSize))
					{		
						if (myHeapAlloc((LPVOID*)&pGroup, groupSize))
						{
							if (MakeAbsoluteSD(pSrcSD, *pDstSD, &sdSize, pDAcl, &daclSize, pSAcl, &saclSize, pOwner, &ownerSize, pGroup, &groupSize))
							{
								result = true;
							}
						}
					}					
				}
			}
		}
	}
	return result;
}

#if 1
bool changeFileOwner(LPTSTR fileName, LPTSTR userName)
{
	bool result = false;
	PSID pSid;
	PSECURITY_DESCRIPTOR pSd, pDstSd;
	if (adjustOwnerPrivilege())
	{	
		if (getSdFromFile(fileName, &pSd))
		{
			if (getSidFromAccount(userName, &pSid))
			{
				if (myMakeAbsoluteSD(pSd, &pDstSd))
				{
					if (SetSecurityDescriptorOwner(pSd, pSid, FALSE))
					{						
						if (SetFileSecurity(fileName, OWNER_SECURITY_INFORMATION, pDstSd))
						{
							result = true;
						}
					}
				}
				else
				{
					printf("errror %d\n", GetLastError());
				}
			}
		}	
	}
	return result;
}
#else
//DACL_SECURITY_INFORMATION
bool changeFileOwner(LPTSTR fileName, LPTSTR userName)
{
	bool result = false;
	DWORD rights = FullRights;
	PSID pUserSid;
	DWORD err = 0;
	PSECURITY_DESCRIPTOR pSD;
	PACL pDAcl;
	if (adjustOwnerPrivilege())
	{		
		//if (ERROR_SUCCESS == GetNamedSecurityInfo(fileName, SE_FILE_OBJECT, OWNER_SECURITY_INFORMATION|DACL_SECURITY_INFORMATION, &pOwnerSid, NULL, &pDAcl, NULL, &pSD))
		{
			if (getSidFromAccount(userName, &pUserSid))
			{
				//pDAcl = (PACL)daclBuffer;
				if ((pDAcl = (PACL)LocalAlloc(LPTR, 1024))!=NULL)
				{
					if (InitializeAcl(pDAcl, 1024, ACL_REVISION))
					{
						if (AddAccessAllowedAce(pDAcl, ACL_REVISION, rights, pUserSid))
						{
							if ((err = SetNamedSecurityInfo(fileName, SE_FILE_OBJECT, DACL_SECURITY_INFORMATION, NULL, NULL, pDAcl, NULL))	== ERROR_SUCCESS)		
							{
								if ((err = SetNamedSecurityInfo(fileName, SE_FILE_OBJECT, OWNER_SECURITY_INFORMATION, pUserSid, NULL, NULL, NULL))	== ERROR_SUCCESS)		
								{
									result = true;
								}
							}
						}
							
						/*
						if ((err = SetNamedSecurityInfo(fileName, SE_FILE_OBJECT, OWNER_SECURITY_INFORMATION, pUserSid, NULL, NULL, NULL))	== ERROR_SUCCESS)		
						{
							result = true;
						}
						*/
					}
				}
			}
			LocalFree(pSD);
		}
	
	}
	return result;
}
#endif




#if 0
void createFileWithUserAccessOnly(LPTSTR fileName, LPTSTR userName)
{
	HANDLE fileHandle;
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = FALSE; 
	DWORD bytesWritten;
	char buffer[256];
	BOOL bPresent = TRUE, bDefault = TRUE;
	DWORD bufferSizeRequested = 0;
	SECURITY_DESCRIPTOR sd;

	if (adjustOwnerPrivilege())
	{
		if (createUserExclusiveSd(userName, &sa.lpSecurityDescriptor))
		{ 
			if ((fileHandle =CreateFile(fileName, GENERIC_ALL, FILE_SHARE_DELETE, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))
				!= INVALID_HANDLE_VALUE)
			{
				for (int i=0; i<256; i++)
				{
					buffer[i]= i;
				}
				if (WriteFile(fileHandle, buffer, 256, &bytesWritten, NULL) && bytesWritten ==256)
				{
					printf("CREATE FILE OK\n");
				}
			
				CloseHandle(fileHandle);
			}
			else
			{
				int err = GetLastError();
			}
		} 
	}

}
#else
void createFileWithUserAccessOnly(LPTSTR fileName, LPTSTR userName)
{
	HANDLE fileHandle;
	SECURITY_ATTRIBUTES sa;
	sa.nLength = sizeof(SECURITY_ATTRIBUTES);
	sa.bInheritHandle = TRUE; 
	DWORD bytesWritten;
	char buffer[256];
	BOOL bPresent = TRUE, bDefault = TRUE;
	DWORD bufferSizeRequested = 0;
	SECURITY_DESCRIPTOR sd;

	if (adjustOwnerPrivilege())
	{
		if (createUserSD(userName, &sa.lpSecurityDescriptor))
		{ 
			if ((fileHandle =CreateFile(fileName, GENERIC_ALL, FILE_SHARE_DELETE, &sa, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))
				!= INVALID_HANDLE_VALUE)
			{
				for (int i=0; i<256; i++)
				{
					buffer[i]= i;
				}
				if (WriteFile(fileHandle, buffer, 256, &bytesWritten, NULL) && bytesWritten ==256)
				{
					printf("ok\n");
				}
			
				CloseHandle(fileHandle);
			}
			else
			{
				int err = GetLastError();
			}
		} 
	}
}
#endif

HANDLE myConvertPrimaryToken(HANDLE hToken)
{
	HANDLE hPrimary = NULL;
	if (DuplicateTokenEx(hToken, TOKEN_ALL_ACCESS, NULL, SecurityImpersonation, TokenPrimary, &hPrimary))
	{
	}
	return hPrimary;
}


bool myCheckAccess(HANDLE hPrimary, LPTSTR fileName)
{
	PSECURITY_DESCRIPTOR pSD;
	if (GetNamedSecurityInfo(fileName, SE_FILE_OBJECT, 0, NULL, NULL, NULL, NULL, &pSD)==ERROR_SUCCESS)
	{
		//if (AccessCheck(pSD, hPrimary, 
	}
	return true;
}

bool checkPrivilege()
{
	return true;
}


bool displayToken(HANDLE htok, bool toEnable)
{
	bool result = false, enable;
	LPBYTE buffer[1024];
	DWORD bufferSize = 1024;
	TCHAR nameBuffer[256];
	DWORD nameBufferSize;
	TOKEN_PRIVILEGES tpOld;
	PTOKEN_PRIVILEGES ptp = (PTOKEN_PRIVILEGES)buffer;
	if (GetTokenInformation(htok, TokenPrivileges, buffer, bufferSize, &bufferSize))
	{
		for (int i=0; i<ptp->PrivilegeCount; i++)
		{
			nameBufferSize = 256;
			if (LookupPrivilegeName(NULL, &ptp->Privileges[i].Luid, nameBuffer, &nameBufferSize))
			{
				enable = toEnable;
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED)
				{				
					enable = false;
					_tprintf(_T("[enabled]"));
				}
				if (ptp->Privileges[i].Attributes  & SE_PRIVILEGE_USED_FOR_ACCESS)
				{
					enable = false;
					_tprintf(_T("[access]"));
				}
				if (ptp->Privileges[i].Attributes & SE_PRIVILEGE_ENABLED_BY_DEFAULT)
				{
					enable = false;
					_tprintf(_T("[default]"));								
				}
				if (ptp->Privileges[i].Attributes &SE_PRIVILEGE_REMOVED)
				{
					enable = false;
					_tprintf(_T("[removed]"));
				}
				if (enable)
				{
					if (enableTokenPrivilege(htok, nameBuffer, tpOld))
					{
						_tprintf(_T("enabled by me..."));
					}
				}


				_tprintf(_T(" [%s]\n"), nameBuffer);
				result = true;
			
			}
			else
			{
				int err  = GetLastError();
			}
		}
	}
	return result;
}

#if 0
bool openFileWithUserProgram(LPTSTR fileName, LPTSTR userName, LPTSTR passWord, LPTSTR programName)
{
	TCHAR commandLine[1024];
	TCHAR domainName[MAX_PATH];
	//DWORD domainNameSize = MAX_PATH;
	TCHAR programNameBuffer[1024];
	bool result = false;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	LPTSTR ptr;
	TCHAR userNameBuffer[MAX_PATH];
	HANDLE hToken, hPrimary;
	int err;

	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	
	if (GetModuleFileName(NULL, programNameBuffer, 1024))
	{
		if ((ptr = _tcsrchr(programNameBuffer, _T('\\')))!= NULL)
		{
			ptr ++;
			_tcscpy(ptr, programName);
			
			_stprintf(commandLine, _T("\"%s\" create \"%s\""), programNameBuffer, fileName);
			
			if (getAccountDomain(userName, domainName))
			{
				_stprintf(userNameBuffer, _T("%s@%s"), userName, domainName);

				if ((hToken = myLogonUser(userName, passWord))!= NULL)
				{
					if ((hPrimary = myConvertPrimaryToken(hToken))!= NULL)
					{
						displayToken(hPrimary, true);
						if (adjustOwnerPrivilege())
						{
							//if (CreateProcessWithLogonW(userNameBuffer, NULL, passWord, 0, NULL, commandLine, 0,  NULL, NULL, &si, &pi))
							if (CreateProcessAsUser(hPrimary, NULL, commandLine, NULL, NULL, TRUE, 0, NULL, NULL, &si, &pi))
							{
								WaitForSingleObject(pi.hProcess, INFINITE);
								result = true;
							}
							else
							{
								err = GetLastError();
							}
						}
					}
				}
				else
				{
					err = GetLastError();
				}

			}
		}
	}
	return result;
}
#else
bool openFileWithUserProgram(LPTSTR fileName, LPTSTR userName, LPTSTR passWord, LPTSTR programName)
{
	TCHAR commandLine[1024];
	TCHAR domainName[MAX_PATH];
	//DWORD domainNameSize = MAX_PATH;
	TCHAR programNameBuffer[1024];
	bool result = false;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	LPTSTR ptr;
	TCHAR userNameBuffer[MAX_PATH];
	HANDLE hToken, hPrimary;
	int err;

	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	
	if (GetModuleFileName(NULL, programNameBuffer, 1024))
	{
		if ((ptr = _tcsrchr(programNameBuffer, _T('\\')))!= NULL)
		{
			ptr ++;
			_tcscpy(ptr, programName);
			
			_stprintf(commandLine, _T("\"%s\" \"%s\""), programNameBuffer, fileName);
			
			if (getAccountDomain(userName, domainName))
			{
				_stprintf(userNameBuffer, _T("%s@%s"), userName, domainName);

				if (CreateProcessWithLogonW(userNameBuffer, NULL, passWord, LOGON_WITH_PROFILE, NULL, commandLine, 0, NULL, NULL, &si, &pi))
				{
					WaitForSingleObject(pi.hProcess, INFINITE);					
					result = true;
				}
				else
				{
					int err = GetLastError();
				}
			}
		}
	}
	return result;
}
#endif


HANDLE myLogonUser(LPTSTR userName, LPTSTR passWord)
{
	WCHAR  szDomain[1] = {NULL};
	WCHAR  szUser[MAX_PATH];
	WCHAR  szPw[MAX_PATH];
	HANDLE hToken = NULL;

	UNICODE_STRING Domain;

	Domain.Buffer = (PWSTR) &szDomain;
	Domain.Length = 0;
	Domain.MaximumLength = 2;

	wcsncpy(szUser, userName, MAX_PATH);
	wcsncpy(szPw, passWord, MAX_PATH);

	//if (!LogonUserW(szUser, Domain.Buffer, szPw, LOGON32_LOGON_NETWORK,
	if (!LogonUserW(szUser, NULL, szPw, LOGON32_LOGON_INTERACTIVE,
		 LOGON32_PROVIDER_DEFAULT, &hToken)) 
	{
		wprintf(L"LogonUser() failed with error %d\n", GetLastError());
		
	}
	return hToken;

}

bool openFileWithUserProgramTest(LPTSTR fileName, LPTSTR userName, LPTSTR domainName, LPTSTR passWord, LPTSTR programName)
{
	TCHAR commandLine[1024];
	TCHAR programNameBuffer[1024];
	bool result = false;
	STARTUPINFO si;
	PROCESS_INFORMATION pi;
	LPTSTR ptr;
	TCHAR userNameBuffer[MAX_PATH];
	HANDLE hToken, hPrimary;
	int err;

	ZeroMemory(&si, sizeof(STARTUPINFO));
	si.cb = sizeof(STARTUPINFO);

	ZeroMemory(&pi, sizeof(PROCESS_INFORMATION));
	
	if (GetModuleFileName(NULL, programNameBuffer, 1024))
	{
		if ((ptr = _tcsrchr(programNameBuffer, _T('\\')))!= NULL)
		{
			ptr ++;
			_tcscpy(ptr, programName);
			
			_stprintf(commandLine, _T("\"%s\" display \"%s\""), programNameBuffer, fileName);			
			printf("before createprocess\n\n");
			if (CreateProcessWithLogonW(userName, domainName, passWord, LOGON_WITH_PROFILE, NULL, commandLine, 0, NULL, NULL, &si, &pi))
			{
				WaitForSingleObject(pi.hProcess, INFINITE);					
				result = true;
			}
			else
			{
				int err = GetLastError();
				printf("create process error %d\n", err);
			}		
		}
	}
	return result;
}


void test101(int argc, LPTSTR* argv)
{
	//LPTSTR userName = _T("root1999");
	LPTSTR userName = argv[1];
	//LPTSTR fileName = _T("e:\\nicknewtest1156.txt");
	LPTSTR fileName = argv[2];
	
	LPTSTR passWord = _T("123456");
	
	LPTSTR programName = _T("fileReader.exe");
	LPTSTR serverName = _T("\\\\nickhp");
	//LPTSTR domainName = _T("NICKHP");
	LPTSTR domainName = argv[3];
	LPTSTR groupName = _T("administrators");
	

	if (deleteUser(userName))
	{
		_tprintf(L"delete user %s ok\n", userName);
	}
	printf("before create user\n\n");
	if (createUser(userName, passWord, domainName))
	{
		_tprintf(L"create user %s ok\n", userName);
	}


	createFileWithUserAccessOnly(fileName, userName);
	{
		//_tprintf(L"create file %s with user %s ok\n", fileName, userName);
	}
	
	if (openFileWithUserProgramTest(fileName, userName,  domainName, passWord, programName))
	{
		
		_tprintf(L"openFileWithUserProgramTest file=%s user=%s domain=%s password=%s program=%s\n", fileName, userName, domainName, passWord, programName);	
	}

}

	//deleteUser(userName);
	//createUser(userName, passWord);
/*
	addUsers(_T("nickhp"), groupName, userName);
	checkUsers(serverName, userName);
	//enumWorkStationUser(_T("nickhp"));
	checkAccount(userName);

	//myLogonUser(userName, passWord);

	//

	//getSidFromAccount(userName, &pSid);
	createFileWithUserAccessOnly(fileName, userName);
	//changeFileOwner(fileName, userName);
	//bool result = compareSidFromAccount(userName, _T("administrator"));

	if (changePassword(_T("root"), passWord))
	{
		if (openFileWithUserProgram(fileName1, _T("root"), passWord, programName))
		{
			printf("OK\n");
		}
	}
*/  


BOOL TakeOwnership(LPTSTR lpszOwnFile)
{
	BOOL bRetval = FALSE;

	HANDLE hToken = NULL;
	PSID pSIDAdmin = NULL;
	PSID pSIDEveryone = NULL;
	PACL pACL = NULL;
	SID_IDENTIFIER_AUTHORITY SIDAuthWorld = SECURITY_WORLD_SID_AUTHORITY;
	SID_IDENTIFIER_AUTHORITY SIDAuthNT = SECURITY_NT_AUTHORITY;
	const int NUM_ACES = 2;
	EXPLICIT_ACCESS ea[NUM_ACES];
	DWORD dwRes;

	// Specify the DACL to use.
	// Create a SID for the Everyone group.
	if (!AllocateAndInitializeSid(&SIDAuthWorld, 1,
	SECURITY_WORLD_RID,
	0,
	0, 0, 0, 0, 0, 0,
	&pSIDEveryone))
	{
		printf("AllocateAndInitializeSid (Everyone) error %u\n", GetLastError());
		goto Cleanup;
	}

	// Create a SID for the BUILTIN\Administrators group.
	if (!AllocateAndInitializeSid(&SIDAuthNT, 2,
	SECURITY_BUILTIN_DOMAIN_RID,
	DOMAIN_ALIAS_RID_ADMINS,
	0, 0, 0, 0, 0, 0,
	&pSIDAdmin))
	{
		printf("AllocateAndInitializeSid (Admin) error %u\n", GetLastError());
		goto Cleanup;
	}

	ZeroMemory(&ea, NUM_ACES * sizeof(EXPLICIT_ACCESS));

	// Set read access for Everyone.
	ea[0].grfAccessPermissions = GENERIC_READ;
	ea[0].grfAccessMode = SET_ACCESS;
	ea[0].grfInheritance = NO_INHERITANCE;
	ea[0].Trustee.TrusteeForm = TRUSTEE_IS_SID;
	ea[0].Trustee.TrusteeType = TRUSTEE_IS_WELL_KNOWN_GROUP;
	ea[0].Trustee.ptstrName = (LPTSTR) pSIDEveryone;

	// Set full control for Administrators.
	ea[1].grfAccessPermissions = GENERIC_ALL;
	ea[1].grfAccessMode = SET_ACCESS;
	ea[1].grfInheritance = NO_INHERITANCE;
	ea[1].Trustee.TrusteeForm = TRUSTEE_IS_SID;
	ea[1].Trustee.TrusteeType = TRUSTEE_IS_GROUP;
	ea[1].Trustee.ptstrName = (LPTSTR) pSIDAdmin;

	if (ERROR_SUCCESS != SetEntriesInAcl(NUM_ACES,
	ea,
	NULL,
	&pACL))
	{
	printf("Failed SetEntriesInAcl\n");
	goto Cleanup;
	}

	// Try to modify the object's DACL.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	DACL_SECURITY_INFORMATION, // change only the object's DACL
	NULL, NULL, // do not change owner or group
	pACL, // DACL specified
	NULL); // do not change SACL

	if (ERROR_SUCCESS == dwRes)
	{
	printf("Successfully changed DACL\n");
	bRetval = TRUE;
	// No more processing needed.
	goto Cleanup;
	}
	if (dwRes != ERROR_ACCESS_DENIED)
	{
	printf("First SetNamedSecurityInfo call failed: %u\n", dwRes);
	goto Cleanup;
	}

	// If the preceding call failed because access was denied,
	// enable the SE_TAKE_OWNERSHIP_NAME privilege, create a SID for
	// the Administrators group, take ownership of the object, and
	// disable the privilege. Then try again to set the object's DACL.

	// Open a handle to the access token for the calling process.
	HANDLE realHandle;
	realHandle = convertPrimaryToken(GetCurrentProcess());
	if (!OpenProcessToken(realHandle,
	TOKEN_ADJUST_PRIVILEGES,
	&hToken))
	{
	printf("OpenProcessToken failed: %u\n", GetLastError());
	goto Cleanup;
	}

	// Enable the SE_TAKE_OWNERSHIP_NAME privilege.
	TOKEN_PRIVILEGES tpOld;
	if (!enableTokenPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, tpOld))
	{
	printf("You must be logged on as Administrator.\n");
	goto Cleanup;
	}

	// Set the owner in the object's security descriptor.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	OWNER_SECURITY_INFORMATION, // change only the object's owner
	pSIDAdmin, // SID of Administrator group
	NULL,
	NULL,
	NULL);

	if (dwRes != ERROR_SUCCESS)
	{
	printf("Could not set owner. Error: %u\n", dwRes);
	goto Cleanup;
	}

	// Disable the SE_TAKE_OWNERSHIP_NAME privilege.
	if (!enableTokenPrivilege(hToken, SE_TAKE_OWNERSHIP_NAME, tpOld))
	{
	printf("Failed SetPrivilege call unexpectedly.\n");
	goto Cleanup;
	}

	// Try again to modify the object's DACL, now that we are the owner.
	dwRes = SetNamedSecurityInfo(
	lpszOwnFile, // name of the object
	SE_FILE_OBJECT, // type of object
	DACL_SECURITY_INFORMATION, // change only the object's DACL
	NULL, NULL, // do not change owner or group
	pACL, // DACL specified
	NULL); // do not change SACL

	if (dwRes == ERROR_SUCCESS)
	{
	printf("Successfully changed DACL\n");
	bRetval = TRUE;
	}
	else
	{
	printf("Second SetNamedSecurityInfo call failed: %u\n", dwRes);
	}

	Cleanup:

	if (pSIDAdmin)
	FreeSid(pSIDAdmin);

	if (pSIDEveryone)
	FreeSid(pSIDEveryone);

	if (pACL)
	LocalFree(pACL);

	if (hToken)
	CloseHandle(hToken);

	return bRetval;

	} 


int _tmain(int argc, LPTSTR* argv)
{

	LPTSTR fileName = argv[2];
	LPTSTR userName = argv[1];

	test101(argc, argv);


	return 0;
}

